unit rxIDEExtEditorInsertFileNameUnit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ButtonPanel;

type

  { TrxIDEExtEditorInsertFileNameForm }

  TrxIDEExtEditorInsertFileNameForm = class(TForm)
    ButtonPanel1: TButtonPanel;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Label1: TLabel;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
  private
    procedure FillFilesList;
  public
    function SelectedFile:string;
  end; 

var
  rxIDEExtEditorInsertFileNameForm: TrxIDEExtEditorInsertFileNameForm;

implementation
uses rxWebStrConsts, SrcEditorIntf, ProjectIntf, LazIDEIntf;

{$R *.lfm}

{ TrxIDEExtEditorInsertFileNameForm }

procedure TrxIDEExtEditorInsertFileNameForm.FormCreate(Sender: TObject);
begin
  FillFilesList;
end;

procedure TrxIDEExtEditorInsertFileNameForm.ListBox1DblClick(Sender: TObject);
begin
  ModalResult:=mrOk;
end;

procedure TrxIDEExtEditorInsertFileNameForm.FillFilesList;
var
  i:integer;
  S, Ext:string;
begin
  ListBox1.Items.Clear;
  if Assigned(LazarusIDE) and Assigned(LazarusIDE.ActiveProject) then
  begin
    for i:=0 to LazarusIDE.ActiveProject.FileCount - 1 do
    begin
      if LazarusIDE.ActiveProject.Files[i].IsPartOfProject then
      begin
        S:=ExtractFileNameOnly(LazarusIDE.ActiveProject.Files[i].Filename);
        ListBox1.Items.Add(S);
      end;
    end;
  end;
end;

function TrxIDEExtEditorInsertFileNameForm.SelectedFile: string;
begin
  if (ListBox1.Items.Count>0) and (ListBox1.ItemIndex>-1) and (ListBox1.ItemIndex < ListBox1.Items.Count) then
  begin
    Result:=ListBox1.Items[ListBox1.ItemIndex];
    if CheckBox1.Checked then
      Result:=ExtractFileNameOnly(Result);
  end
  else
    Result:='';
end;

end.

